//+------------------------------------------------------------------+
//|                                                                  |
//|  In no event will author be liable for any damages whatsoever.   |
//|                      Use at your own risk.                       |
//|                                                                  |
//+------------------- DO NOT REMOVE THIS HEADER --------------------+

#define SIGNAL_NONE 0
#define SIGNAL_BUY   1
#define SIGNAL_SELL  2
#define SIGNAL_CLOSEBUY 3
#define SIGNAL_CLOSESELL 4

#property link      "http://eatbuilder.com/"

extern int MagicNumber = 0;
extern bool SignalMail = False;
extern bool EachTickMode = True;
extern double Lots = 1.0;
extern int Slippage = 3;
extern bool UseStopLoss = True;
extern int StopLoss = 20;
extern bool UseTakeProfit = True;
extern int TakeProfit = 10;
extern bool UseTrailingStop = false;
extern int TrailingStop = 30;
 
extern int dailtyPipGoal = 10;
extern double openChartTime= 10.00; 
extern double closeChartTime=19.00;
extern int shift = 1;
extern string currencyPair = "GBPUSD" ;
extern int smallLossSL = 5;
extern bool is5DigitBroker= false;

double buyOrderOpenPrice,sellOrderOpenPrice ;
double currentBid,currentAsk ;
double StopLossLevel, TakeProfitLevel; 
int dailyProfitInPips;

int BarCount;
int Current;
bool TickCheck = False;
//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init() {
   BarCount = Bars;

   if (EachTickMode) Current = 0; else Current = 1;

   return(0);
}
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit() {
   return(0);
}
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+



int start() {
 
   int Order = SIGNAL_NONE;
   int Total, Ticket;
   

   if (EachTickMode && Bars != BarCount) TickCheck = False;
   Total = OrdersTotal();
   Order = SIGNAL_NONE;

   //+------------------------------------------------------------------+
   //| Variable Begin                                                   |
   //+------------------------------------------------------------------+
   
   bool hasOrderBuy,hasOrderSell;         
   bool isInSessionTime ;
   bool hasToUseSmallLoss;
   bool min15LcdBuySignal,min15LcdSellSignal,min1LcdBuySignal,min1LcdSellSignal ;
   bool min1BSBuySignal,min1BSSellSignal ;

   int Cur_Hour=Hour();             // Server time in hours
   double Cur_Min =Minute();           //  Server time in minutes   
   double Cur_time=Cur_Hour + Cur_Min/100; // Current Server time 
      
   //+------------------------------------------------------------------+
   //| Variable End                                                     |
   //+------------------------------------------------------------------+   
   
   double stealthLCDSignal15Min = iCustom(currencyPair,PERIOD_M15,"Stealth LCD V10",0,Current + shift);    
   double stealthLCDSignal1Min = iCustom(currencyPair,PERIOD_M1,"Stealth LCD V10",0,Current + shift);
   
   double stealthBuySellSignal1Min = iCustom(currencyPair,PERIOD_M1,"Stealth BUY SELL V10",0,Current + shift);
      
   currentBid = Bid;
   currentAsk = Ask;
   
   if(stealthLCDSignal15Min == -3){
      min15LcdBuySignal = true;
      min15LcdSellSignal = false ;
   }else if (stealthLCDSignal15Min > 2000){
      min15LcdBuySignal = false;
      min15LcdSellSignal = true ;
   }
   
   if(stealthLCDSignal1Min == -3){
      min1LcdBuySignal = true;
      min1LcdSellSignal = false ;
   }else if (stealthLCDSignal1Min > 2000){
      min1LcdBuySignal = false;
      min1LcdSellSignal = true ;
   }
   
   if(stealthBuySellSignal1Min == -3){
      min1BSBuySignal = true;
      min1BSSellSignal = false ;
   }else if (stealthBuySellSignal1Min > 2000){
      min1BSBuySignal = false;
      min1BSSellSignal = true ;
   }
      
   if (Cur_time>=openChartTime && Cur_time<=closeChartTime) {
      isInSessionTime = true;
   }else {
      isInSessionTime = false; 
   }
   
   if(isInSessionTime && dailyProfitInPips < dailtyPipGoal ){
     if(min15LcdBuySignal){
      if(min1LcdBuySignal && min1BSBuySignal){
         hasOrderBuy = true;
         hasOrderSell = false;
         hasToUseSmallLoss = false;
      }else{
         //hasToUseSmallLoss = true;
         hasOrderBuy = false;
      }
   }else if(min15LcdSellSignal){
      if(min1LcdSellSignal && min1BSSellSignal){
         hasOrderBuy = false;
         hasOrderSell = true;
         hasToUseSmallLoss = false;
      }else{
         //hasToUseSmallLoss = true;
         hasOrderSell = false;
      }         
   }
   }else{
         hasOrderBuy = false;
         hasOrderSell = false;
         dailyProfitInPips = 0;
   }
    
   /*if(hasToUseSmallLoss){
      if(hasOrderBuy){
         if(currentBid - buyOrderOpenPrice <= (smallLossSL) * (-1)* Point){ 
            hasOrderBuy = false;
         }
      }else if (hasOrderSell){
         if(currentAsk- sellOrderOpenPrice <= smallLossSL * Point){ 
            hasOrderSell = false;
         }      
      }
   }*/
   
   if(hasOrderBuy){
      
   }
   
   
   //Check position
   bool IsTrade = False;

   for (int i = 0; i < Total; i ++) {
      OrderSelect(i, SELECT_BY_POS, MODE_TRADES);
      if(OrderType() <= OP_SELL &&  OrderSymbol() == Symbol()) {
         IsTrade = True;
         if(OrderType() == OP_BUY) {
            //Close

            //+------------------------------------------------------------------+
            //| Signal Begin(Exit Buy)                                           |
            //+------------------------------------------------------------------+

               if (!hasOrderBuy){
                  dailyProfitInPips += OrderProfit()/OrderLots()/MarketInfo(OrderSymbol(),MODE_TICKVALUE);
                  Order = SIGNAL_CLOSEBUY;
                 
               } 

            //+------------------------------------------------------------------+
            //| Signal End(Exit Buy)                                             |
            //+------------------------------------------------------------------+

            if (Order == SIGNAL_CLOSEBUY && ((EachTickMode && !TickCheck) || (!EachTickMode && (Bars != BarCount)))) {
               
               OrderClose(OrderTicket(), OrderLots(), Bid, Slippage, MediumSeaGreen);
               
               if (SignalMail) SendMail("[Signal Alert]", "[" + Symbol() + "] " + DoubleToStr(Bid, Digits) + " Close Buy");
               if (!EachTickMode) BarCount = Bars;
               IsTrade = False;               
               continue;
            }
            //Trailing stop
            if(UseTrailingStop && TrailingStop > 0) {                 
               if(Bid - OrderOpenPrice() > Point * TrailingStop) {
                  if(OrderStopLoss() < Bid - Point * TrailingStop) {
                     OrderModify(OrderTicket(), OrderOpenPrice(), Bid - Point * TrailingStop, OrderTakeProfit(), 0, MediumSeaGreen);
                     if (!EachTickMode) BarCount = Bars;
                     continue;
                  }
               }
            }
         } else {
            //Close

            //+------------------------------------------------------------------+
            //| Signal Begin(Exit Sell)                                          |
            //+------------------------------------------------------------------+
            
               if (!hasOrderSell){
                  
                  Order = SIGNAL_CLOSESELL;
                  dailyProfitInPips += OrderProfit()/OrderLots()/MarketInfo(OrderSymbol(),MODE_TICKVALUE);
               } 
               
            //+------------------------------------------------------------------+
            //| Signal End(Exit Sell)                                            |
            //+------------------------------------------------------------------+

            if (Order == SIGNAL_CLOSESELL && ((EachTickMode && !TickCheck) || (!EachTickMode && (Bars != BarCount)))) {
               
               OrderClose(OrderTicket(), OrderLots(), Ask, Slippage, DarkOrange);    
                          
               if (SignalMail) SendMail("[Signal Alert]", "[" + Symbol() + "] " + DoubleToStr(Ask, Digits) + " Close Sell");
               if (!EachTickMode) BarCount = Bars;
               IsTrade = False;                
               continue;
            }
            //Trailing stop
            if(UseTrailingStop && TrailingStop > 0) {                 
               if((OrderOpenPrice() - Ask) > (Point * TrailingStop)) {
                  if((OrderStopLoss() > (Ask + Point * TrailingStop)) || (OrderStopLoss() == 0)) {
                     OrderModify(OrderTicket(), OrderOpenPrice(), Ask + Point * TrailingStop, OrderTakeProfit(), 0, DarkOrange);
                     if (!EachTickMode) BarCount = Bars;
                     continue;
                  }
               }
            }
         }
      }
   }

   //+------------------------------------------------------------------+
   //| Signal Begin(Entry)                                              |
   //+------------------------------------------------------------------+

   if (hasOrderBuy) Order = SIGNAL_BUY;

   if (hasOrderSell) Order = SIGNAL_SELL;

   

   //+------------------------------------------------------------------+
   //| Signal End                                                       |
   //+------------------------------------------------------------------+

   //Buy
   if (Order == SIGNAL_BUY && ((EachTickMode && !TickCheck) || (!EachTickMode && (Bars != BarCount)))) {
      if(!IsTrade) {
         //Check free margin
         if (AccountFreeMargin() < (1000 * Lots)) {
            Print("We have no money. Free Margin = ", AccountFreeMargin());
            return(0);
         }

         if (UseStopLoss) StopLossLevel = Ask - StopLoss * Point; else StopLossLevel =  0.0;
         if (UseTakeProfit) TakeProfitLevel = Ask + TakeProfit * Point; else TakeProfitLevel = 0.0;

         Ticket = OrderSend(Symbol(), OP_BUY, Lots, Ask, Slippage, StopLossLevel, TakeProfitLevel, "Buy(#" + MagicNumber + ")", MagicNumber, 0, DodgerBlue);
         
         if(Ticket > 0) {
            if (OrderSelect(Ticket, SELECT_BY_TICKET, MODE_TRADES)) {
				Print("BUY order opened : ", OrderOpenPrice());
				buyOrderOpenPrice = OrderOpenPrice();
                if (SignalMail) SendMail("[Signal Alert]", "[" + Symbol() + "] " + DoubleToStr(Ask, Digits) + " Open Buy");
			} else {
				Print("Error opening BUY order : ", GetLastError());
			}
         }
         if (EachTickMode) TickCheck = True;
         if (!EachTickMode) BarCount = Bars;
         return(0);
      }
   }

   //Sell
   if (Order == SIGNAL_SELL && ((EachTickMode && !TickCheck) || (!EachTickMode && (Bars != BarCount)))) {
      if(!IsTrade) {
         //Check free margin
         if (AccountFreeMargin() < (1000 * Lots)) {
            Print("We have no money. Free Margin = ", AccountFreeMargin());
            return(0);
         }

         if (UseStopLoss) StopLossLevel = Bid + StopLoss * Point; else StopLossLevel = 0.0;
         if (UseTakeProfit) TakeProfitLevel = Bid - TakeProfit * Point; else TakeProfitLevel = 0.0;

         Ticket = OrderSend(Symbol(), OP_SELL, Lots, Bid, Slippage, StopLossLevel, TakeProfitLevel, "Sell(#" + MagicNumber + ")", MagicNumber, 0, DeepPink);
         if(Ticket > 0) {
            if (OrderSelect(Ticket, SELECT_BY_TICKET, MODE_TRADES)) {
				Print("SELL order opened : ", OrderOpenPrice());
				sellOrderOpenPrice = OrderOpenPrice();
                if (SignalMail) SendMail("[Signal Alert]", "[" + Symbol() + "] " + DoubleToStr(Bid, Digits) + " Open Sell");
			} else {
				Print("Error opening SELL order : ", GetLastError());
			}
         }
         if (EachTickMode) TickCheck = True;
         if (!EachTickMode) BarCount = Bars;
         return(0);
      }
   }

   if (!EachTickMode) BarCount = Bars;

   return(0);
}
//+------------------------------------------------------------------+
 